library color;

{ Remarque importante concernant la gestion de mmoire de DLL : ShareMem doit
  tre la premire unit de la clause USES de votre bibliothque ET de votre projet
  (slectionnez Projet-Voir source) si votre DLL exporte des procdures ou des
  fonctions qui passent des chanes en tant que paramtres ou rsultats de fonction.
  Cela s'applique  toutes les chanes passes de et vers votre DLL --mme celles
  qui sont imbriques dans des enregistrements et classes. ShareMem est l'unit
  d'interface pour le gestionnaire de mmoire partage BORLNDMM.DLL, qui doit
  tre dploy avec vos DLL. Pour viter d'utiliser BORLNDMM.DLL, passez les
  informations de chanes avec des paramtres PChar ou ShortString. }

uses
  Windows,
  graphics,
  dialogs,
  Sysutils,
  Math;

type
  pColRGB = ^ColRGB;
  ColRGB=record
     Red,Green,Blue:byte;
  end;
  pColHSV = ^ColHSV;
  ColHSV=record
     Hue,Saturation,Value:integer;
  end;

{$R *.res}

function RecupParam(R:pInteger;ParamNumber:integer):integer;stdcall;
var
 i:integer;
begin
  for i :=1 to ParamNumber-1 do Inc(R,20);
  result:=R^;
end;

function HextoByte(str:Ansistring):byte;
begin
 if ord(str[1]) in [48..57] then result := ord(str[1])-48
 else if ord(str[1]) in [65..70] then result := ord(str[1])-55
 else result:= 0;
 result := result * 16;
 if ord(str[2]) in [48..57] then result := result + ord(str[2])-48
 else if ord(str[2]) in [65..70] then result := result + ord(str[2])-55;
end;

function ByteToHex(InByte:byte):Ansistring;
const Digits:array[0..15] of char='0123456789ABCDEF';
begin
 result:=digits[InByte shr 4]+digits[InByte and $0F];
end;


procedure IntExpandRGB(codeRGB:Ansistring;Pixel:pColRGB);
begin
  Pixel.Red  := HextoByte(codeRGB[1]+codeRGB[2]);
  Pixel.Green:= HextoByte(codeRGB[3]+codeRGB[4]);
  Pixel.Blue := HextoByte(codeRGB[5]+codeRGB[6]);
end;

procedure IntContractRGB(codeRGB:pAnsistring;pixel:pColRGB);
begin
  codeRGB^ := ByteToHex(pixel.Red)+ByteToHex(pixel.Green)+ByteToHex(pixel.Blue);
end;

function ExpandRGB(pR,pG,pB:pInteger;codeRGB:pAnsistring):integer;stdcall;
var
  Pixel:ColRGB;
begin
  IntExpandRGB(codeRGB^,@Pixel);
  pR^:=Pixel.Red;
  pG^:=Pixel.Green;
  pB^:=Pixel.Blue;
  result := 1;
end;

function ContractRGB(R,G,B:integer;panoRGB:integer):integer;stdcall;
var
  Pixel:ColRGB;
  RGB:string;
begin
  Pixel.Red:=R;
  Pixel.Green:=G;
  Pixel.Blue:=B;

  IntContractRGB(@RGB,@Pixel);
  CopyMemory(Pbyte(pstring(panoRGB)^),Pbyte(RGB),6);
  result :=1;
end;


function DesktopColor(const X, Y: Integer): TColor;
var
  c: TCanvas;
begin
  c := TCanvas.Create;
  try
    c.Handle := GetWindowDC(GetDesktopWindow);
    Result   := GetPixel(c.Handle, X, Y);
  finally
    c.Free;
  end;
end;

function TColorToHex(Color : TColor) : string;
begin
   Result :=
     ByteToHex(GetRValue(Color)) +
     ByteToHex(GetGValue(Color)) +
     ByteToHex(GetBValue(Color)) ;
end;

function GetMouseXY(panoRGB:integer): integer;stdcall;
var
  Position:TPoint; // position de la souris
  RGB:string;   // Chaine de caractres contenant le rsultat

begin
  GetCursorPos(Position);
  RGB := TColorToHex(DesktopColor(Position.X, Position.Y));
  CopyMemory(Pbyte(pstring(panoRGB)^),Pbyte(RGB),6);
  // Permet de savoir si il y a eu un clic de souris
  if (GetAsyncKeyState(VK_LBUTTON) AND $8000)<>0 then result := 1
  else result := 0
end;


function HSVtoRGB(pH,pS,pV:pInteger;panoRGB:integer):integer;stdcall;
var
  PixelRGB:ColRGB;
  PixelHSV:ColHSV;
  Hue,Saturation,Value:double;
  Red,Green,Blue:double;
  vI,v1,v2,v3,v4,vH:double;
  RGB:string;
begin
 PixelHSV.Hue := pH^;
 PixelHSV.Saturation := pS^;
 PixelHSV.Value := pV^;
 Hue := PixelHSV.Hue;

 Saturation := PixelHSV.Saturation/100; // % -> decimal
 Value := PixelHSV.Value/100;
  if (Saturation = 0) then
  begin
    PixelRGB.Red := PixelHSV.Value;
    PixelRGB.Green := PixelRGB.Red;
    PixelRGB.Blue := PixelRGB.Red;
  end
  else begin
    if (Hue = 360) then Hue := 0;

    vH := Hue / 60;
    vI := Floor(vH);
    v4 := vH - vI;

    v1 := Value * (1-Saturation);
    v2 := Value * (1-(v4*Saturation));
    v3 := Value * (1- ((1-v4)*Saturation));

    // Valeur par dfaut :
    Red := Value; Green := v1; Blue := v2;

    if vI=0 then
        begin
          Red := Value;Green := v3;Blue := v1;
        end
    else if vI=1 then
        begin
          Red := v2; Green := Value; Blue := v1;
        end
    else if vI=2 then
        begin
          Red := v1; Green := Value; Blue := v3;
        end
    else if vI=3 then
        begin
          Red := v1; Green := v2; Blue := Value;
        end
    else if vI=4 then
        begin
          Red := v3; Green := v1; Blue := Value;
        end;
    PixelRGB.Red := floor(Red*255);
    PixelRGB.Green := floor(Green*255);
    PixelRGB.Blue := floor(Blue*255);
  end;
  IntContractRGB(@RGB,@PixelRGB);
  CopyMemory(Pbyte(pstring(panoRGB)^),Pbyte(RGB),6);
  result:=1;
end;

function RGBtoHSV(pH,pS,pV:pInteger;RGB:pAnsiString):integer;stdcall;
var
  PixelRGB:ColRGB;
  Red,Green,Blue:double;
  Max,Min,Delta:double;
  Hue,Saturation:double;
begin
  IntExpandRGB(RGB^,@PixelRGB);
  Red := PixelRGB.Red/255;
  Green := PixelRGB.Green/255;
  Blue := PixelRGB.Blue/255;

  Max  := Math.Max(Red,Math.Max(Green,Blue));
  Min  := Math.Min(Red,Math.Min(Green,Blue));
  Delta:= Max - Min;

  // Hue :
  if (Max = Min) then Hue := 0
  else if (Max = Red) then
    begin
      Hue := Round((60 * (Green-Blue)/Delta)+360);
      While (Hue > 360) do Hue := Hue -360;
    end
  else if (Max = Green) then Hue := (60 * (Green - Red) / Delta) + 120
  else Hue:= (60 * (Red-Green)-Delta)+240;
  pH^:=round(Hue);
  // Saturation
  if Max = 0 then Saturation := 0
  else Saturation := ((1-(Min / Max))*100);
  pS^:= round(Saturation);
  // Value
  pV^:= round(Max*100);
  result := 1;
end;

function WindowTopMost(hwnd, flag: integer):integer; stdcall; export;
begin
    if flag=1 then
        begin
        SetForegroundWindow(hwnd);
        SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,
            SWP_NOACTIVATE or SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE);
        end
    else
        SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,
            SWP_NOACTIVATE or SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE);
    result := 1;
end;
exports
  HSVtoRGB,
  RGBtoHSV,
  ContractRGB,
  ExpandRGB,
  WindowTopMost,
  RecupParam,
  GetMouseXY;

begin
end.
